# DrumKit

**WARNING! This framework is currently in very early development, it may be broken or may break at any time.**

DrumKit is a plugin-powered, full-stack Web development framework for Node.js.

## Installation

DrumKit is dependent on Node.js and NPM. If you have both, you can install DrumKit globally:

```bash
npm install -g drumkit
```

It is important to install this globally so that you have access to the `drumkit` command across your system.
All DrumKit modules on the other hand will be installed locally in each of your DrumKit projects.

## Getting Started

DrumKit will bootstrap a project directory for you with the `create` command:

```bash
cd ~/myapps
drumkit create new-app
```

This will generate a DrumKit application in `~/myapps/new-app` and will use `npm` to install
your dependencies. Once your app is installed, you can start the server:

```bash
cd new-app
drumkit start
```

By default, your app will be running at `http://localhost:8080`.

## Running the Console

You also can interact with your code in a REPL by firing up the console:

```bash
cd path/to/your/app
drumkit console
```

## Now Build Your App!

1. Build models with [dk-model](http://github.com/chrisjpowers/dk-model#readme) (see also [dk-model-couchdb](http://github.com/chrisjpowers/dk-model-couchdb#readme) and [dk-couchdb](http://github.com/chrisjpowers/dk-couchdb#readme)).

2. Build view templates and helpers with [dk-template](http://github.com/chrisjpowers/dk-template#readme).

3. Build routes with [dk-routes](http://github.com/chrisjpowers/dk-routes#readme).

4. Check out these other DrumKit plugins:
  
  * [dk-assets](http://github.com/chrisjpowers/dk-assets#readme)
  * [dk-core](http://github.com/chrisjpowers/dk-core#readme)
  * [dk-server](http://github.com/chrisjpowers/dk-server#readme)
  * [dk-transport](http://github.com/chrisjpowers/dk-transport#readme)
  * [dk-websockets](http://github.com/chrisjpowers/dk-websockets#readme)

5. Build your own plugins with `drumkit plugin [pluginName]`
