fs = require "fs"
exec = require('child_process').exec
_ = require "underscore"

dk.command "create", "drumkit create appName :: Bootstraps a new DrumKit app at ./appName.", (opts) ->
  appName = if opts.shift then opts.shift() else opts
  templateDir = fs.realpathSync(__dirname) + "/../site-template"
  newDir = "#{process.cwd()}/#{appName}"

  console.log "Creating a DrumKit project in #{newDir}..."

  exec "cp -R #{templateDir} #{newDir}; mv #{newDir}/gitignore #{newDir}/.gitignore", (error, stdout, stderr) ->
    console.log stdout
    if error
      console.log "Error creating your DrumKit project: #{stderr}"
    else
      console.log "Running npm install..."
      exec "cd #{newDir}; npm install", (error, stdout, stderr) ->
        console.log stdout
        if error
          console.log "Error running npm install: #{stderr}"
        else
          console.log successMessage

  successMessage = """

    ========================================================================
      Your DrumKit app "#{appName}" has been created! You will want to
      customize these files with your project info:

        database.json
        package.json
      
      To start the server:

        cd #{process.cwd()}/#{appName} 
        drumkit start

      For full documentation, visit http://drumkitjs.com
    ========================================================================

    """

dk.command "version", "drumkit version :: Display Drumkit's version number", ->
  package = JSON.parse fs.readFileSync("#{__dirname}/../package.json")
  console.log package.version

dk.command "help", "drumkit help :: Displays this message.", (opts) ->
  cmds = _.map(dk.commands(), (v,k) -> [k,v])
  sorted = _.sortBy(cmds, (arr) -> arr[0])

  console.log "Available Drumkit Commands:"
  for tuple in sorted
    console.log "  #{tuple[1].summary}"
